Ginkgo: gko::ReadableFromMatrixData< ValueType, IndexType > Class Template Reference

| Ginkgo Generated from branch based on main. Ginkgo version 1.11.0 A numerical linear algebra library targeting many-core architectures

Loading...
Searching...
No Matches
gko::ReadableFromMatrixData< ValueType, IndexType > Class Template Referenceabstract
Linear Operators

A LinOp implementing this interface can read its data from a matrix_data structure. More...

`#include <ginkgo/core/base/lin_op.hpp>`

Inheritance diagram for gko::ReadableFromMatrixData< ValueType, IndexType >:
[legend]

## Public Types
using | value_type = ValueType
using | index_type = IndexType

## Public Member Functions
virtual void | read (const matrix_data< ValueType, IndexType > &data)=0
| Reads a matrix from a matrix_data structure.
void | read (const matrix_assembly_data< ValueType, IndexType > &data)
| Reads a matrix from a matrix_assembly_data structure.
virtual void | read (const device_matrix_data< ValueType, IndexType > &data)
| Reads a matrix from a device_matrix_data structure.
virtual void | read (device_matrix_data< ValueType, IndexType > &&data)
| Reads a matrix from a device_matrix_data structure.

## Detailed Description

template<typename ValueType, typename IndexType>
class gko::ReadableFromMatrixData< ValueType, IndexType >

A LinOp implementing this interface can read its data from a matrix_data structure.

## Member Function Documentation

## ◆ read() [1/4]

template<typename ValueType, typename IndexType>

virtual void gko::ReadableFromMatrixData< ValueType, IndexType >::read | ( | const device_matrix_data< ValueType, IndexType > & | data | ) |
| inlinevirtual

Reads a matrix from a device_matrix_data structure.

Parameters

  data | the device_matrix_data structure.

References gko::device_matrix_data< ValueType, IndexType >::copy_to_host(), and read().

## ◆ read() [2/4]

template<typename ValueType, typename IndexType>

void gko::ReadableFromMatrixData< ValueType, IndexType >::read | ( | const matrix_assembly_data< ValueType, IndexType > & | data | ) |
| inline

Reads a matrix from a matrix_assembly_data structure.

Parameters

  data | the matrix_assembly_data structure

References gko::matrix_assembly_data< ValueType, IndexType >::get_ordered_data(), and read().

## ◆ read() [3/4]

template<typename ValueType, typename IndexType>

virtual void gko::ReadableFromMatrixData< ValueType, IndexType >::read | ( | const matrix_data< ValueType, IndexType > & | data | ) |
| pure virtual

Reads a matrix from a matrix_data structure.

Parameters

  data | the matrix_data structure

Implemented in gko::matrix::Fbcsr< ValueType, IndexType >.

Referenced by read(), read(), and read().

## ◆ read() [4/4]

template<typename ValueType, typename IndexType>

virtual void gko::ReadableFromMatrixData< ValueType, IndexType >::read | ( | device_matrix_data< ValueType, IndexType > && | data | ) |
| inlinevirtual

Reads a matrix from a device_matrix_data structure.

The structure may be emptied by this function.

Parameters

  data | the device_matrix_data structure.

References read().

The documentation for this class was generated from the following file:

- ginkgo/core/base/lin_op.hpp